/************************************************************************/
/************************************************************************/
/*									*/
/*                        RADICALLY PUBLIC DOMAIN                       */
/*									*/
/* Utility to scan for mail waiting for incoming callers.		*/
/*									*/
/* Author : William Beebe.						*/
/* Started: 01 May 1988							*/
/*									*/
/*                        RADICALLY PUBLIC DOMAIN                       */
/*									*/
/************************************************************************/
/************************************************************************/

#include	<stdio.h>
#include	<stdarg.h>
#include	<stdlib.h>
#include	<fcntl.h>
#include	<sys\stat.h>
#include	<dir.h>
#include	<dos.h>
#include	<io.h>
#include	<alloc.h>
#include	"yabbs.h"
#include	"yamchek.h"
#include	"yamlib.h"

#undef	toupper

jmp_buf	mark;			/* setjump/longjump critical context.	*/
struct	tm	*time_list;	/* structure for time functions.	*/
struct	_old_usr	user;	/* Opus 1.03b user structure.		*/
struct	_old_sys	sys;	/* Opus 1.03b system structure.		*/
struct	_msg	msgs;		/* message header structure.		*/

static	struct	ffblk	msgsblk;	/* disk transfer block.		*/

int	sflg[100];

int	status = 0,		/* general program status.	*/
	cstack_flag = yes,	/* allow command stacking.	*/
	itxt,			/* text buffer pointer.		*/
	maxtext,		/* highest byte read in.	*/
	low_msg,		/* lowest message # found.	*/
	high_msg = 0,		/* highest message # found.	*/
	cur_num,		/* current message # read.	*/
	last_msg,		/* last message read.		*/
	last_msg_area,		/* last message area visited.	*/
	num_msgs,		/* number of messages found.	*/
	ln_cnt = 0,		/* line counter.		*/
	limit,			/* upper/lower message limit.	*/
	pause_flag   = yes,	/* if set will allow pause.	*/
	ansi_flag,		/* ansi index flag.		*/
	msg_path_len;		/* length of message area path.	*/

char	msg_name[10],		/* buffer for building #.MSG.	*/
	msg_path[80],		/* the current working path.	*/
	filename[14],		/* filename from user structure.*/
	out_buf[80],		/* directory bbs name.		*/
	mail_text[81*60],	/* mail text area.		*/

	*whiteln[] =		/* selects white characters on black.	*/
	{"\033[1;40;37m",""},

	*grayln[] =		/* selects gray characters on black.	*/
	{"\033[0;40;37m",""},

	*yellowln[] =		/* selects yellow characters on black.	*/
	{"\033[1;40;33m",""},

	*cyanln[] =		/* selects cyan characters on black.	*/
	{"\033[0;40;36m",""},

	*lcyanln[] =	/* selects light cyan characters on black.	*/
	{"\033[1;40;36m",""},

	*lblueln[] =	/* selects light blue characters on black.	*/
	{"\033[1;40;34m",""},

	*erase_eol[] =		/* erase to end-of-line.		*/
	{"\033[K",""},

	*start_text[] =		/* used to start text at row 5,		*/
	{"\033[5H",""},		/* column 1 in ANSI page mode.		*/

	*cls_ln[] =
	{"\033[H\033[0;30;36m\033[2J\033[J","\f"},

	*types[]=
	{
	"List\r\n",
	"Read\r\n",
	"Cleanup\r\n"
	},

	*help[]=
	{
	"\r\n\n     L)ist  will  list your new mail in a two  line  format,",
	"\r\n     with  the message number, date, and who it is  from  on",
	"\r\n     the first line and the subject on the second.",

	"\r\n\n     R)ead will display the full contents of the message  as",
	"\r\n     if Opus were displaying it. This includes the date  and",
	"\r\n     header information. The \"SEEN-BY\" lines in echomail are",
	"\r\n     suppressed.  Please note that in Read the new  messages",
	"\r\n     are  marked  as received, but your  last  message  read",
	"\r\n     marker  in that area is not modified.  Listed  messages",
	"\r\n     are NOT marked as received.",

	"\r\n\n     C)leanup  will list your new mail just like L)ist,  but",
	"\r\n     will allow you to mark your mail as having already been",
	"\r\n     read, as if you had read it. This allows you to cleanup",
	"\r\n     message  bases  on several boards you  may  visit  that",
	"\r\n     carry  the  same message bases you visit. It's  a  good",
	"\r\n     idea  to  clean out message areas from  time  to  time,",
	"\r\n     because if you don't, you face the boring task of going",
	"\r\n     through each message base and reading each message just",
	"\r\n     to  mark is as received. This method gives you  a  much",
	"\r\n     faster method and a chance to see if it needs  marking.",
	"\r\n     You and your sysop will appreciate it :-).\r\n",0
	},

	*help2[] =
	{
	"\r\n\n     M)arking  the mail marks it as Received, as if you  had",
	"\r\n     read it. Yamchek then moves on to the next new message.",

	"\r\n\n     S)kipping  this  message  leaves it as  New  Mail,  and",
	"\r\n     allows you to find it in the main Opus message base.",

	"\r\n\n     R)eading  the mail is the same as if you  had  selected",
	"\r\n     general  read, and will mark the message  as  Received.",
	"\r\n     However, instead of remaining in Read mode, you go back",
	"\r\n     to  the list mode. You only read the message  (open  it",
	"\r\n     up)  if you can't remember the contents. You  can  skip",
	"\r\n     through those you do remember or know are new.\r\n",0
	};

/************************************************************************/
/*									*/
/************************************************************************/

void fossil_cmd( void )

{
if (!initcomm())
	{
	status = 1;
	puts("FOSSIL not loaded or not captured.");
	longjmp(mark,-1);
	}

get_fossil_info();

if (carrier())
	{
	local_kbd = no;
	purge_outbuf();		/* flush everything good.		*/
	purge_inbuf();
	if (invoke_tick_timer( yes ) == -1)
		puts("Could not install tick timer code.");
	return;
	}
setdtr( no );
local_kbd = yes;
}

/************************************************************************/

cls_cmd()
{
if (user.flags & _formfeed)
	rawdisplay(cls_ln[ansi_flag]);
else
	sendbyte('\n');
}

/************************************************************************/

/*	Integer version of more in yansi.c.				*/

word	pascal	more( int page_size )

{
int	c;
char	more_ln[]=	"\r\nMore? [Y] ";

if (ln_cnt < page_size)
	return( yes );

if (!(user.flags & _more))
	return( yes );

ln_cnt = 0;
rawdisplay( more_ln );
c = getbyte();
sendbyte('\r');
if (c == 'y' || c == 'Y' || c == '\r')
	return( yes );
else
	{
	pause_flag = no;
	return( no );
	}
}

/************************************************************************/

/*

This procedure attempts to locate ANY *.MSG messages. If it
finds any, it then will find the lowest numbered message and
the highest numbered message.

*/

void	findmsg( void )

{
int	j,
	done;			/* flag for ending message file search.	*/

char	*k;

num_msgs = 0;			/* zero the message counter.		*/
high_msg = 0;			/* set low and high message markers for	*/
low_msg = 20000;		/* search through message subdirectory.	*/
strcat(msg_path+msg_path_len,"*.MSG");

done = findfirst(msg_path,&msgsblk,0);	/* go find first occurrence.	*/

while (!done)				/* while not done find msgs.	*/
	{
	num_msgs++;			/* count number of messages.	*/
	j = atoi(msgsblk.ff_name);	/* convert msg name to number.	*/
	high_msg = max(j,high_msg);	/* find message number limits.	*/
	low_msg = min(j,low_msg);
	done  = findnext(&msgsblk);	/* find next message number.	*/
	}

}

/************************************************************************

parse_line() parses a line out of the message text buffer read into
mail_text[] by the calling routine. It converts CR/LF pairs correctly, ignores
WS style "soft" returns, and wraps the line correctly if it extends beyond
79 consecutive characters. The routine returns a NULL terminated line in
text, starting at the 'j' position in mail_text[j].

*/

parse_line( register int j )

{
register int i;
int	lastspace = 79,
	nextchar = 79;

for (i=0;i<79 && itxt < maxtext; i++, j++, itxt++)
	{
	switch((byte)mail_text[itxt] & 0x7F)
		{
		case '\r':
		itxt++;
		out_buf[j] = 0;
		return;

		case '\n':
		--i;
		--j;
		break;

		case ' ':
		lastspace = j;
		nextchar = itxt;
		default:
		out_buf[j] = mail_text[itxt];
		break;
		}
	}

if (itxt == maxtext)	/* exit parser if end of text.		*/
	out_buf[j] = 0;
else
	{
	out_buf[lastspace] = 0;
	itxt = nextchar + 1;
	}
}

/************************************************************************/

/*

Show_header reads in the message header and displays it from a handle
passed to it in fh.

*/

void	show_header( struct _msg *header, int message )

{
display("%s#%s%-4d %s  ",grayln[ansi_flag],yellowln[ansi_flag],message,header->date);

if (header->attr & MSGREAD)	rawdisplay(" RCVD");

else	if (strcmp(user.name,header->to)==0)
		rawdisplay(" New Mail");

if (header->attr & MSGPRIVATE)	rawdisplay(" PVT");
if (header->attr & MSGCRASH)	rawdisplay(" CRASH");
if (header->attr & MSGFILE)	rawdisplay(" w/FILE");
if (header->attr & MSGORPHAN)	rawdisplay(" ORPHAN");
if (header->attr & MSGKILL)	rawdisplay(" KILL/SENT");
display("%s\r\n",grayln[ansi_flag]);


display("From: %s%-24s%s",yellowln[ansi_flag],header->from,grayln[ansi_flag]);

if (header->reply)
	display("    Reply to: %s%d%s",yellowln[ansi_flag],header->reply,grayln[ansi_flag]);

display("\r\nTo:   %s%-24s%s",yellowln[ansi_flag],header->to,grayln[ansi_flag]);
if (header->up)
	display("    See also: %s%d%s",yellowln[ansi_flag],header->up,grayln[ansi_flag]);

display("\r\n%s: %s%s%s\r\n",(header->attr & MSGFILE ? "File" : "Subj"),yellowln[ansi_flag],header->subject,cyanln[ansi_flag]);
}

/************************************************************************/

/*

Show_msg reads in the opened message from a handle passed to it.

*/

show_msg( void )

{
int	i,
	j,
	k,
	num_lines,
	m2;

itxt = k = 0;
num_lines = 16;
ln_cnt=0;

k = sprintf(out_buf,"\r\n%s",erase_eol[ansi_flag]);

while (itxt < maxtext && mail_text[itxt])
	{
	rawdisplay(start_text[ansi_flag]);	/* only for the first line.	*/

	for (num_lines = 16;num_lines && itxt < maxtext && mail_text[itxt];num_lines--)
		{
		parse_line(k);

		if (out_buf[k] == 0x01 || strncmp(out_buf+k,"SEEN-BY:",8)==0)
			num_lines++;
		else
			rawdisplay(out_buf);
		}

	if (itxt < maxtext)
		{
		if (!more( 0 ))
			return;
		}
	}

if (!ansi_flag)
	{
	m2 = 20 - num_lines;
	out_buf[k] = 0;

	do
		rawdisplay(out_buf);	/* clear the rest of the screen.*/
	while (num_lines--);

	display("\033[%d;1H",m2);
	}
else
	sendbyte('\n');
}

/************************************************************************/

/*

read_msg attempts to open the message number passed to it. It will attempt
to open #.MSG, or the first one it finds in the direction of search that
exists AFTER the target message. It will return the NEXT message number
after the one it has read in.

*/

void	read_msg( int message, int fh )

{
int	c,
	i;

cls_cmd();
maxtext = read(fh, mail_text, sizeof(mail_text));

show_header( &msgs, message );
ansi_flag = ((user.flags ^ (_more | _ansi | _formfeed)) ? 1 : 0 );
show_msg();
ansi_flag = (user.flags & _more ? 0 : 1 );

if(pause_flag)
	rawdisplay("\r\nPress any key to continue...");
getbyte();
sendbyte('\n');

msgs.attr |= MSGREAD;		/* set the message read flag.		*/
lseek(fh,0L,SEEK_SET);		/* re-write header portion.		*/
write (fh, (char *)&msgs, sizeof(msgs));

}

/************************************************************************/

/*	List messages.							*/

void	list_msg( int mread, int m_num )

{
int	i,	/* general index.					*/
	c,
	j,	/* general scratch area.				*/
	fh;	/* file handle for listing headers.			*/

pause_flag=yes;
while (m_num <= high_msg)
	{

	do	/* search for messages in a given area.			*/
		{
		sprintf(msg_path+msg_path_len,"%u.MSG",m_num);
		}
	while ((fh = open(msg_path, O_RDWR | O_BINARY)) == -1 && ++m_num != high_msg);

	read (fh, (char *)&msgs, sizeof(msgs));

	if (strcmp(user.name,msgs.to) == 0 && (msgs.attr & MSGREAD) == 0)
		{
		switch (mread)
			{
			case 0:
			msgs.date[10] = 0;
			display("%s#%-4d%s %s",whiteln[ansi_flag],m_num,cyanln[ansi_flag],msgs.date);
			display("- From: %s%s%s\r\n",lblueln[ansi_flag],msgs.from,cyanln[ansi_flag]);
			display("                  Subj: %s%s%s\r\n",lcyanln[ansi_flag],msgs.subject,cyanln[ansi_flag]);
			if (!more( 23 ))
				return;
			break;

			case 1:
			read_msg( m_num, fh );
			break;
	
			case 2:
			msgs.date[10] = 0;
			display("%s#%-4d%s %s",whiteln[ansi_flag],m_num,cyanln[ansi_flag],msgs.date);
			display("- From: %s%s%s\r\n",lblueln[ansi_flag],msgs.from,cyanln[ansi_flag]);
			display("                  Subj: %s%s%s\r\n",lcyanln[ansi_flag],msgs.subject,cyanln[ansi_flag]);
			do
			{
			display("\r\n%sM%s)ark, %sS%s)kip, or %sR%sead new mail? [%sM,s,r,?=help%s] ",yellowln[ansi_flag],cyanln[ansi_flag],yellowln[ansi_flag],cyanln[ansi_flag],yellowln[ansi_flag],cyanln[ansi_flag],yellowln[ansi_flag],cyanln[ansi_flag]);
			c = toupper(getbyte());
			if (c == '?')
				for (i=0;*help2[i] ; i++)
					rawdisplay(help2[i]);
			}
			while(c == '?');
			switch(c)
				{
				case 'R':
				read_msg( m_num, fh );
				break;

				case '\r':
				case 'M':
				msgs.attr |= MSGREAD;		/* set the message read flag.		*/
				lseek(fh,0L,SEEK_SET);		/* re-write header portion.		*/
				write (fh, (char *)&msgs, sizeof(msgs));
				rawdisplay("Marked");
				break;

				case 'S':
				default:
				rawdisplay("Skipped");
				break;
				}

			sendbyte('\n');
			break;

			default:
			}
		}
	m_num++;
	close(fh);
	}
}

/************************************************************************/
/************************************************************************/
/************************************************************************/

main(argc,argv)

int	argc;
char	*argv[];

{
int	fh,	/* integer file handle for low-level file i/o.		*/
	i,
	j,
	k,
	l,
	done,
	type = 0,
	find_default = yes,
	c;	/* temporary character variable for getbyte()		*/

if (setjmp(mark) != 0)	/* set context point here for program aborts.	*/
	goto quit_main;

for(i=1;i<argc;i++)	/* parse out any switches passed to us.		*/
	{
	if (*argv[i] == '-')
		{
		++argv[i];
		switch(toupper(*argv[i]))
			{
			case 'M':	/* set specific areas to check.	*/
			while (*argv[++i] != '-' && i<argc)
				sflg[atoi(argv[i])] = -1;
			--i;
			find_default = no;
			break;

			case 'P':	/* set port number.		*/
			COMMPORT = atoi(++argv[i]);
			break;

			case 'S':	/* turn on snoop mode.		*/
			snoop = yes;
			break;

			case 'T':	/* set time limit.		*/
			j = atoi(++argv[i]);
			if (j) time_left = j;
			break;
			}
		}
	}

/* try to open lastuser file.	*/

if ((fh=open("lastuser.bbs",O_RDONLY | O_BINARY)) == -1)
	{
	status = 1;
	puts("Can't open lastuser.bbs file.");
	goto quit_main;
	}

read(fh,(char *)&user,sizeof(user));	/* read in lastuser file.	*/
close(fh);

fossil_cmd();

ansi_flag = (user.flags & _ansi ?  0 : 1);

cls_cmd();
display("\r\n%sYAMCHEK 1.0, port %d, last compiled %s\r\n",cyanln[ansi_flag],COMMPORT,__DATE__);
display("Copyright 1988 William H. Beebe IV, 1:363/1.0\r\n\n");
display("Welcome, %s%s%s. You are allowed %s%d%s minutes in Yamchek.\r\n",yellowln[ansi_flag],user.name,cyanln[ansi_flag],whiteln[ansi_flag],time_left,cyanln[ansi_flag]);
display("\r\nCheck for new mail? [%sY,n%s] ",whiteln[ansi_flag],cyanln[ansi_flag]);
c = toupper(getbyte());
if ( c == '\r') c = 'Y';
sendbyte(c);
if ( c != 'Y') goto quit_main;

do
{
display("\r\n%sL%s)ist, %sR%s)ead, or %sC%s)leanup new mail? [%sL,r,c,?=help%s] ",yellowln[ansi_flag],cyanln[ansi_flag],yellowln[ansi_flag],cyanln[ansi_flag],yellowln[ansi_flag],cyanln[ansi_flag],yellowln[ansi_flag],cyanln[ansi_flag]);
c = toupper(getbyte());
if (c == '?')
	for (i=0;*help[i] && (more( 23 ) == yes) ; i++)
		rawdisplay(help[i]);
}
while(c == '?');

switch(c)
	{
	case 'R':	type = 1;	break;
	case 'C':	type = 2;	break;
	case 'L':
	case '\r':
	default:	type = 0;
	}

rawdisplay(types[type]);

if (find_default)
	{
	done = findfirst("system??.bbs",&msgsblk,0);	/* go find first system file.	*/
	while (!done)				/* while not done find msgs.	*/
		{
		i = atoi(msgsblk.ff_name+6);	/* convert msg name to number.	*/
		sflg[i] = -1;
		done  = findnext(&msgsblk);	/* find next message number.	*/
		}
	}

for (i=1;i<100;i++)
	{
	if (!sflg[i])
		continue;

	sprintf(filename,"system%d.bbs",i);

	if ((fh = open(filename,O_RDONLY | O_BINARY)) == -1)
		continue;

	read(fh, &sys, sizeof(sys));
	close(fh);
	if (sys.msgpath[0] == 0)
		continue;

	if ((sys.priv+2) > (user.priv+2))
		continue;

	strncpy(msg_path,sys.msgpath,sizeof(msg_path));
	msg_path_len = strlen(msg_path);

	for (j=k=strlen(sys.msgpath)-2;j && sys.msgpath[j] != '\\';j--);
	for (l=0;j<k;l++)
		out_buf[l] = toupper(sys.msgpath[++j]);
	out_buf[l] = 0;

	findmsg();
	if (!high_msg)
		continue;

	display("\r\nCheck area #%-2d, %-8s [%4d:%4d] [%sY,n%s]? ",i,out_buf,low_msg,high_msg,whiteln[ansi_flag],cyanln[ansi_flag]);
	c = toupper(getbyte());
	if ( c == '\r') c = 'Y';
	sendbyte(c);
	if ( c != 'Y')
		continue;
	sendbyte('\n');

	if (!more( 23 ))
		goto quit_main;
	list_msg( type , low_msg);
	}

rawdisplay("\r\nPress any key to continue...");
getbyte();
sendbyte('\n');

quit_main:

invoke_tick_timer( no );	/* remove tick code from FOSSIL.*/
uninitcomm();	/* flush any pending data to caller.		*/
exit(status);
}
